diff system-image.sh @ 1350:7eabfa815c90

Split up system-image.sh into root-image.sh, linux-kernel.sh, and system-image.sh. Rename CROSS_HOST_ARCH to CROSS_COMPILER_HOST.
author Rob Landley <rob@landley.net>
date Mon, 18 Apr 2011 18:41:04 -0500
parents 6ea4204209d0
children 9252453c40d0
line wrap: on
line diff
--- a/system-image.sh	Mon Apr 18 08:04:46 2011 -0500
+++ b/system-image.sh	Mon Apr 18 18:41:04 2011 -0500
@@ -1,7 +1,6 @@
 #!/bin/bash
 
-# Package a root filesystem directory into a filesystem image, with
-# associated bootable kernel binary and launch scripts.
+# Combine a filesystem image and kernel with emulator launch scripts.
 
 source sources/include.sh || exit 1
 
@@ -9,116 +8,12 @@
 
 read_arch_dir "$1"
 
-# Do we have our prerequisites?
-
-if [ -z "$NATIVE_ROOT" ]
-then
-  [ -z "$NO_NATIVE_COMPILER" ] &&
-    NATIVE_ROOT="$BUILD/root-filesystem-$ARCH"
-
-  [ -e "$NATIVE_ROOT" ] ||
-    NATIVE_ROOT="$BUILD/simple-root-filesystem-$ARCH"
-fi
-
-if [ ! -d "$NATIVE_ROOT" ]
-then
-  [ -z "$FAIL_QUIET" ] && echo No "$NATIVE_ROOT" >&2
-  exit 1
-fi
-
-# Announce start of stage.  (Down here after the recursive call above so
-# it doesn't get announced twice.)
-
-echo "=== Packaging system image from root-filesystem"
-
-# The initramfs packaging uses the kernels build infrastructure, so extract
-# it now.
-
-setupfor linux
-
-[ -z "$SYSIMAGE_TYPE" ] && SYSIMAGE_TYPE=squashfs
-echo "Generating $SYSIMAGE_TYPE root filesystem from $NATIVE_ROOT."
-
-# Embed an initramfs image in the kernel?
-
-if [ "$SYSIMAGE_TYPE" == "initramfs" ]
-then
-  $CC usr/gen_init_cpio.c -o my_gen_init_cpio || dienow
-  ./my_gen_init_cpio <(
-      "$SOURCES"/toys/gen_initramfs_list.sh "$NATIVE_ROOT" || dienow
-      [ ! -e "$NATIVE_ROOT"/init ] &&
-        echo "slink /init /sbin/init.sh 755 0 0"
-      [ ! -d "$NATIVE_ROOT"/dev ] && echo "dir /dev 755 0 0"
-      echo "nod /dev/console 660 0 0 c 5 1"
-    ) > initramfs_data.cpio || dienow
-  echo Initramfs generated.
-
-  # No need to supply an hda image to the emulator.
-
-  IMAGE=
-
-  MORE_KERNEL_CONFIG='CONFIG_BLK_DEV_INITRD=y\nCONFIG_INITRAMFS_SOURCE="initramfs_data.cpio"\nCONFIG_INITRAMFS_COMPRESSION_GZIP=y'
-
-elif [ "$SYSIMAGE_TYPE" == "ext2" ]
-then
-  # Generate a 64 megabyte ext2 filesystem image from the $NATIVE_ROOT
-  # directory, with a temporary file defining the /dev nodes for the new
-  # filesystem.
-
-  [ -z "$SYSIMAGE_HDA_MEGS" ] && SYSIMAGE_HDA_MEGS=64
-
-  IMAGE="image-${ARCH}.ext2"
-  DEVLIST="$WORK"/devlist
-
-  echo "/dev d 755 0 0 - - - - -" > "$DEVLIST" &&
-  echo "/dev/console c 640 0 0 5 1 0 0 -" >> "$DEVLIST" &&
-
-  # Produce a filesystem with the currently used space plus 20% for filesystem
-  # overhead, which should always be big enough.
-
-  BLOCKS=$[1024*(($(du -m -s "$NATIVE_ROOT" | awk '{print $1}')*12)/10)]
-  [ $BLOCKS -lt 4096 ] && BLOCKS=4096
-
-  genext2fs -z -D "$DEVLIST" -d "$NATIVE_ROOT" -b $BLOCKS -i 1024 \
-    "$STAGE_DIR/$IMAGE" &&
-  rm "$DEVLIST" || dienow
-
-  # Extend image size to HDA_MEGS if necessary, keeping it sparse.  (Feeding
-  # a larger -b size to genext2fs is insanely slow, and not particularly
-  # sparse.)
-
-  echo "$(stat -c %s "$STAGE_DIR/$IMAGE") -lt $SYSIMAGE_HDA_MEGS"
-
-  if [ ! -z "$SYSIMAGE_HDA_MEGS" ] &&
-     [ $((`stat -c %s "$STAGE_DIR/$IMAGE"` / (1024*1024) )) -lt "$SYSIMAGE_HDA_MEGS" ]
-  then
-    echo resizing image to $SYSIMAGE_HDA_MEGS
-    dd if=/dev/zero of="$STAGE_DIR/$IMAGE" bs=1k count=1 seek=$[1024*1024-1] &&
-    resize2fs "$STAGE_DIR/$IMAGE" ${SYSIMAGE_HDA_MEGS}M || dienow
-    echo resize complete
-  fi
-
-elif [ "$SYSIMAGE_TYPE" == "squashfs" ]
-then
-  IMAGE="image-${ARCH}.sqf"
-  mksquashfs "${NATIVE_ROOT}" "$STAGE_DIR/$IMAGE" -noappend -all-root \
-    ${FORK:+-no-progress} -p "/dev d 755 0 0" \
-    -p "/dev/console c 666 0 0 5 1" || dienow
-else
-  echo "Unknown image type." >&2
-  dienow
-fi
-
-echo Image generation complete.
-
-# Build linux kernel for the target
-
-[ -z "$BOOT_KARCH" ] && BOOT_KARCH=$KARCH
-make ARCH=$BOOT_KARCH $LINUX_FLAGS KCONFIG_ALLCONFIG=<(getconfig linux && echo -e "$MORE_KERNEL_CONFIG") allnoconfig >/dev/null &&
-make -j $CPUS ARCH=$BOOT_KARCH $DO_CROSS $LINUX_FLAGS $VERBOSITY &&
-cp "$KERNEL_PATH" "$STAGE_DIR/zImage-$ARCH"
-
-cleanup
+cd "$BUILD/linux-kernel-$ARCH_NAME" &&
+KERNEL="$(ls)" &&
+ln "$KERNEL" "$STAGE_DIR" &&
+cd "$BUILD/root-image-$ARCH" &&
+IMAGE="$(ls)" &&
+ln "$IMAGE" "$STAGE_DIR" || dienow
 
 # Provide qemu's common command line options between architectures.
 
@@ -133,8 +28,8 @@
 
 qemu_defaults()
 {
-  echo -n "-nographic -no-reboot -kernel \"$2\" \$WITH_HDC \$WITH_HDB"
-  [ "$SYSIMAGE_TYPE" != "initramfs" ] && echo -n " -hda \"$1\""
+  echo -n "-nographic -no-reboot -kernel $KERNEL \$WITH_HDC \$WITH_HDB"
+  [ "$SYSIMAGE_TYPE" != "initramfs" ] && echo -n " -hda $IMAGE"
   echo -n " -append \"$(kernel_cmdline)\" \$QEMU_EXTRA"
 }
 
@@ -147,7 +42,7 @@
 run_emulator()
 {
   [ ! -z "\$DEBUG" ] && set -x
-  $(emulator_command "$IMAGE" zImage-$ARCH)
+  $(emulator_command)
 }
 
 if [ "\$1" != "--norun" ]